#include<bits/stdc++.h>
using namespace std;
long long f[1010];
const long long p=10000007;

long long mod(long long a,long long b)
{
	if (a%b==0)
		return 0;
	if (a>0)
		return a%b;
	return b+(a%b);
}
int main()
{
//	freopen("f.in","r",stdin);
//	freopen("f2.out","w",stdout);
	ios::sync_with_stdio(false);
	int n,m;
	cin>>n>>m;
	int x;
	if (n%2==0)
		x=1;
	else
		x=-1;
	for (int i=1;i<n;i++)
	{
		f[i]=mod(m,p)*mod(m-1,p)*x;
		for (int j=1;j<i;j++)
		{
			f[i]=mod(f[i],p)*mod(m-1,p);
		}
		x*=-1;
	}
	long long ans=0;
	for (int i=1;i<n;i++)
		ans=mod(ans+f[i],p);
	cout<<mod(ans,p)<<endl;
	return 0;
}

